{{- if .Values.backendNodejs.enabled -}}
apiVersion: apps/v1
kind: Deployment
metadata:
  name: {{ include "fullname" (list . .Values.backendNodejs.name) }}
  labels:
    {{- include "common.labels" (list . .Values.backendNodejs.name)  | nindent 4 }}
spec:
  replicas: {{ .Values.backendNodejs.replicaCount }}
  strategy:
    {{- .Values.backendNodejs.strategy | default .Values.global.strategy | toYaml | nindent 4 }}
  selector:
    matchLabels:
      {{- include "selector.labels" (list . .Values.backendNodejs.name) | nindent 6 }}
  template:
    metadata:
      {{- with .Values.global.podAnnotations }}
      annotations:
        {{- toYaml . | nindent 8 }}
      {{- end }}
      labels:
        {{- include "selector.labels" (list . .Values.backendNodejs.name) | nindent 8 }}
    spec:
      {{- with .Values.global.imagePullSecrets }}
      imagePullSecrets:
        {{- toYaml . | nindent 8 }}
      {{- end }}
      serviceAccountName: {{ include "serviceAccountName" (list . .Values.backendNodejs.name) }}
      securityContext:
        {{- include "default_pod_security_context" . | nindent 8 }}
      containers:
      - name: {{  .Values.backendNodejs.name }}

        image: "{{ .Values.backendNodejs.image.repository }}:{{ .Values.backendNodejs.image.tag | default .Chart.AppVersion }}"
        imagePullPolicy: {{ .Values.global.imagePullPolicy }}

        ports:
        - name: http
          containerPort: {{ .Values.backendNodejs.service.port }}
          protocol: TCP

        {{- include "liveness.and.readiness.probe" . | nindent 8 }}
        resources:
          {{- toYaml .Values.backendNodejs.resources | nindent 10 }}
      affinity:
        podAntiAffinity:
          preferredDuringSchedulingIgnoredDuringExecution:
          - weight: 100
            podAffinityTerm:
              labelSelector:
                matchExpressions:
                - key: app.kubernetes.io/name
                  operator: In
                  values:
                  - {{  .Values.backendNodejs.name }}
              topologyKey: kubernetes.io/hostname
{{- end -}}
